/*******************************************************************
*  include file defines
*******************************************************************/

#include "device.h"
#include "stdio.h"
#include "stdlib.h"
#include "math.h"

#define PI_VALUE 3.1415926535897932384626433832795


/*******************************************************************
*  SPI flash commands
*******************************************************************/
		#define		FLASH_NORMAL_RD			(0x03)
		#define 	FLASH_STAT_RD			(0x05)  //	Read Status Register
		#define 	FLASH_RD_ID				(0x9F)	//	Read JEDEC ID
		//----------------------------------------------------------------------
		#define 	FLASH_SECT_ERASES		(0xD8)	//	Block Erase (64KB)
		//----------------------------------------------------------------------
		#define		FLASH_WR_EN				(0x06)  //	Set Write Enable Latch
		#define 	FLASH_PAGE_PROGRAM		(0x02)	//	Page Program
		//----------------------------------------------------------------------
		#define 	DUMMY_BYTE				(0x00)	//      dummy word, used in read operations
		#define 	WIP                     (0x01)	//      Check the write in progress bit of the SPI status register
		#define 	WEL                     (0x02)	//      Check the write enable bit of the SPI status register
		//----------------------------------------------------------------------
		#define 	FLASH_PAGE_SIZE			256
		#define 	FLASH_BLOCK_SIZE		0x10000
		#define		FLASH_BLOCK_COUNT		32
		//----------------------------------------------------------------------
		#define 	FLASH_MAN_ID			0x20
		#define 	FLASH_DEV_ID			0xBA16


/*******************************************************************
*  function prototypes
*******************************************************************/

void Init_ADCM40x_PLL(char MSEL, char DF, char CSEL, char SSEL);
void Init_BUFF(void);
void Init_SPI2(void);
unsigned char FLASH_Byte_access(unsigned char Databyte);
void FLASH_Verify_codes(void);
void Erase_flash(unsigned char Block_ID);
void Write_flash(unsigned char Block_ID, unsigned char* flash_page_data_buff, unsigned long long data_count);
void Write_flash_page(unsigned int PAGE_ADDR, unsigned char* flash_page_data_buff, unsigned short page_data_count);
unsigned char Compare_Flash_Data(unsigned char Block_ID, unsigned char* WR_BUFF, unsigned int data_count);
void FLASH_wait_for_status(unsigned char flag, unsigned char state);
unsigned char FLASH_Read_STAT_Reg(unsigned char REG_ID);
void check_block(unsigned char Block_count);
void Select_Flash(void);
void Deselect_Flash(void);
